unit tw16ex3u;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MMSystem, Buttons, Tabnotbk, FileCtrl, Gauges,
  WaveIn, WaveOut, IOFile, Slider; {these 4 units came with Twave eval
  note that slider is not part of Twave, just a demo widgit
  note that when you use File IO routines, you need to add IOFile to
  the uses clause, in addition to waveIn and waveOut}

type
  TMAIN = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    Timer2: TTimer;
    Gauge1: TGauge;
    log: TMemo;

    btSetFormat: TButton;
    btClose: TBitBtn;
    btClear: TBitBtn;
    btHelp: TBitBtn;

    paInfo: TPanel;
    paStatus: TPanel;
    paFormat: TPanel;
    Panel1: TPanel;
    nbProperties: TTabbedNotebook;
    GroupBox1 : TGroupBox;
    GroupBox2: TGroupBox;
    wiActivationLevel: TLabel;
    wiCurLevel: TLabel;
    wiAutoActivation: TLabel;
    wiBitsPerSample: TLabel;
    wiBlockAlign: TLabel;
    wiBlockSize: TLabel;
    wibytesPerSec: TLabel;
    wiCapacity: TLabel;
    wiChannels: TLabel;
    wiDeviceID: TLabel;
    wiSamplesPerSec: TLabel;
    woBitsPerSample: TLabel;
    woBlockAlign: TLabel;
    woBytesPerSec: TLabel;
    woCapacity: TLabel;
    woChannels: TLabel;
    woDeviceID: TLabel;
    woSamplesPerSec: TLabel;
    laErrorMsg: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label5: TLabel;
    Bevel6: TBevel;
    Bevel1: TBevel;
    btRecord: TSpeedButton;
    btPause: TSpeedButton;
    btPlay: TSpeedButton;

    procedure FormCreate(Sender: TObject);
    procedure InitDemoComponents(Sender: TObject);
  {User controls for this demo:}
    procedure tbSpeakerVolChange(Sender: TObject);
    procedure tbActivationLevelChange(Sender: TObject);
    procedure btSetFormatClick(Sender: TObject);
    procedure btRecordClick(Sender: TObject);
    procedure btPlayClick(Sender: TObject);
    procedure btClearClick(Sender: TObject);
    procedure btPauseClick(Sender: TObject);
    procedure btHelpClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);

 {highly specific to demo:}
    procedure showProperties;

 {twave component events:}
    procedure WaveInput1WaveInput(Sender: TObject);
    procedure WaveOutput1WaveOutput(Sender: TObject);
    procedure WaveInput1Overflow(Sender: TObject);
    procedure WaveInput1Mute(Sender: TObject);
    procedure WaveOutput1End(Sender: TObject);
    procedure showInputLevel(Sender: TObject);


    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);

  private
    size : Word;
    buffer : PChar;
    buffersize : word;
    cursize : word;
  public
    {Public declarations }

    WaveInput1: TWaveInput;
    WaveOutput1: TWaveOutput;
    tbSpeakerVol: TSlider;
    tbActivationLevel: TSlider;

  end;
const ID : LongInt = 1;
var
  MAIN: TMAIN;
  fTMP : file;         {tmp audio file}

implementation

{$R *.DFM}


procedure TMAIN.FormCreate(Sender: TObject);
begin
 {create Twave components at runtime, so that
 demo does not require components installed to VCL pallet}
 initDemoComponents(Self);

 {set output format to match input format}
 waveOutput1.matchFormat(waveInput1);

 {progress bar is a visual representations of the ring buffers}
 Gauge1.maxValue := waveOutput1.capacity;

{displays the design/run time properties for demo:
 you will observe how selecting different wave formats
 affects the properties}
   showProperties;

 {set the volume slider position to the current system volume setting:}
   WaveOutput1.Open;
   tbSpeakerVol.value:=integer(WaveOutput1.GetVolume) div 655;
   WaveOutput1.Close;
end;

procedure TMAIN.InitDemoComponents(Sender: TObject);
begin
(* waveInput1 and waveOutput1 create and initialization code
would not be required if the components were installed to the
Delphi VCL pallet.  The components are created here, in the
form create method, to make testing of these demo projects possible
without having first to install the components.*)
waveInput1 := TwaveInput.create(self);
with waveInput1 do begin
    DeviceID := -1;
    Capacity := 100;
    Asynchronous := False;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BlockAlign := 2;
    BitsPerSample := 16;
    AutoActivation := True;
    ActivationLevel := 3;
    preFrame := False;
    postFrame := 0;
    BlockSize := 12500;
    OnMute := WaveInput1Mute;
    OnOverflow := WaveInput1Overflow;
    OnWaveInput := WaveInput1WaveInput;
    Left := 80;
    Top := 72;
end;
waveOutput1 := TwaveOutput.create(self);
with waveOutput1 do begin
    DeviceID := -1;
    Capacity := 100;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BitsPerSample := 16;
    OnEnd := WaveOutput1End;
    OnWaveOutput := WaveOutput1WaveOutput;
    Left := 80;
    Top := 72;
end;
{Slider is not part of Twave; it is a unauthorized hack modification
of slider.pas by Colin Wilson - (woozle@cix.compulink.co.uk);
It serves for this demo, although the paint method does not work
properly under any but the default orientation and size property settings.
It is for Delphi 1.0 Twave demo purposes only.}
tbActivationLevel := TSlider.create(self);
with tbActivationLevel do begin
     parent := self;
     top :=  296;
     left := 176;
     maximum := 100;
     OnValueChange := tbActivationLevelChange;
end;

tbSpeakerVol := TSlider.create(self);
with tbSpeakerVol do begin
     parent := self;
     top :=  336;
     left := 176;
     selHighColor := clRed;
     OnValueChange := tbSpeakerVolChange;
end;
end;


procedure TMAIN.btSetFormatClick(Sender: TObject);
var w : word;
    wiError, woError : word;
    stWaveFormat : string;

begin
   if (waveInput1.state = wisOpen) or
      (waveOutput1.state = wosOpen) then
    begin
      MessageDlg('Please stop record/play before making format change', mtInformation,
       [mbOk], 0);
      exit;
     end;
   stWaveFormat := WaveInput1.SelectFormat;
   if (stWaveFormat = 'Cancel') or (stWaveFormat = '') then exit;

   begin
   {display the selected format}
     paFormat.caption := stWaveFormat;
   {current wave format is also always available as a string value
     by evaluating the ACMFormat property}

     waveOutput1.matchFormat(waveInput1);
   {not all formats displayed by ACM are supported, so we still need to test
    if we have a valid format for the system:}
      wiError:=WaveInput1.IsFormatSupported(WaveInput1.PFWF);
      woError:=WaveOutput1.IsFormatSupported(WaveOutput1.PFWF);
   {a returned value of 0 means that the format is supported}

      showProperties;
      if ((wiError <> 0) or (woError <> 0)) then
         begin
           paInfo.caption := 'format is not supported';
           btRecord.enabled := false;
           btPlay.enabled := false;
         end else
         begin
           paInfo.caption := 'format is supported';
           btRecord.enabled := true;
           btPlay.enabled := true;
         end;
   end;
end;

procedure TMAIN.showProperties;
{all of the design time properties are shown for the demo;
 see the help file for run-time only properties}
begin
{WaveInput properties}
  wiActivationLevel.caption := intToStr(waveInput1.ActivationLevel);
  wiBitsPerSample.caption := intToStr(waveInput1.bitsPerSample);
  wiBlockAlign.caption := intToStr(waveInput1.BlockAlign);
  wiBlockSize.caption := intToStr(waveInput1.BlockSize);
  wiBytesPerSec.caption := intToStr(waveInput1.BytesPerSec);
  wiCapacity.caption := intToStr(waveInput1.Capacity);
  wiChannels.caption := intToStr(waveInput1.Channels);
  wiDeviceID.caption := intToStr(waveInput1.DeviceID);
  wiSamplesPerSec.caption := intToStr(waveInput1.SamplesPerSec);
  wicurLevel.caption := intToStr(waveInput1.curLevel div 100);
  if waveInput1.autoActivation then wiautoActivation.caption := 'true' else
     wiautoActivation.caption := 'false';

{WaveOutput properties}
  woBitsPerSample.caption := intToStr(waveOutput1.bitsPerSample);
  woBlockAlign.caption := intToStr(waveOutput1.BlockAlign);
  woBytesPerSec.caption := intToStr(waveOutput1.BytesPerSec);
  woCapacity.caption := intToStr(waveOutput1.Capacity);
  woChannels.caption := intToStr(waveOutput1.Channels);
  woDeviceID.caption := intToStr(waveOutput1.DeviceID);
  woSamplesPerSec.caption := intToStr(waveOutput1.SamplesPerSec);
end;

procedure TMAIN.tbSpeakerVolChange(Sender: TObject);
var W : Word;
begin
    W:=(tbSpeakerVol.Value)*655;
    WaveOutput1.SetVolume(W,W);
    tbSpeakerVol.selHighEnd := tbSpeakerVol.value+ 5;
end;

procedure TMAIN.tbActivationLevelChange(Sender: TObject);
begin
   waveInput1.ActivationLevel:=tbActivationLevel.Value * 100;
   wiActivationLevel.Caption:=IntToStr(waveInput1.ActivationLevel div 100);
end;

procedure TMAIN.btRecordClick(Sender: TObject);
begin
if btPause.down then btPause.down := false;
if btRecord.down then
  begin
     if WaveInput1.IsFormatSupported(WaveInput1.PFWF)<>0 then exit;
     paStatus.caption := 'Recording';
     {tbActivationLevel.selHighEnd:=tbActivationLevel.maximum;}
     AssignFile(fTMP,'record.snd');
     rewrite(fTMP,1);
     Timer2.Enabled:=true;
     WaveInput1.Open;
     WaveInput1.Start;
   end else {btRecord.down = false}
   begin
      paStatus.caption := 'Save Audio Input:';
      tbActivationLevel.selHighEnd:=0;
      WaveInput1.Stop;
      WaveInput1.Close;
      Timer2.Enabled:=false;
      CloseFile(fTMP);
      if SaveDialog1.Execute then
      begin
         CopyToWaveFile( 'record.snd',
                          SaveDialog1.FileName,
                          WaveInput1.PFWF,
                          WaveInput1.sizeFWF);
         paStatus.caption := 'Audio Input Saved';
      end else
         paStatus.caption := 'Audio Input Canceled';
  end;
end;

procedure TMAIN.btPlayClick(Sender: TObject);
var count : word;
begin
if waveInput1.state = wisOpen then {assuming half duplex}
   begin
     btPlay.down := false;
     exit;
   end;
if btPause.down then btPause.down := false;
if btPlay.down then
  begin
  WaveOutput1.Capacity:=20;
  size:=OpenWaveFile( FileListBox1.FileName,
                      WaveOutput1.PFWF,
                      WaveOutput1.sizeFWF);
  if size<1 then
    begin
      paStatus.caption := 'No file selected';
      btPlay.down := false;
      CloseWaveFile; 
      exit;
    end;
     paStatus.caption := 'Playing';
     paInfo.caption := '';
     paFormat.caption := WaveOutput1.ACMFormat;
     btRecord.enabled := false;
     WaveOutput1.Close;
     WaveOutput1.Capacity:=20;
     if WaveOutput1.Open then begin

     if WaveOutput1.PFWF^.nBlockAlign >8 then
      buffersize:=WaveOutput1.PFWF^.nBlockAlign * 5 else
      buffersize:=10000;

     GetMem(buffer,buffersize);
     repeat
     cursize:=readWaveBlock(buffer,buffersize);
     if cursize<>0 then WaveOutput1.AddBlock(buffer,cursize,ID);
     Inc(ID);
     until (cursize<>buffersize) or (WaveOutput1.MessageCount=WaveOutput1.Capacity);
     if (cursize<>buffersize) then CloseWaveFile; 
     Gauge1.maxValue:=size;
     paInfo.caption:=intTostr(size)+' bytes';
     Gauge1.progress:=0;
     WaveOutput1.PlayBuffer;
     WaveOutput1.PlayBuffer;
     Timer1.Enabled:=true;
    end;
  end else
  begin
     WaveOutput1.Stop;
     WaveOutput1.Close;
     CloseWaveFile; 
     WaveOutput1.ClearRingBuffer;
     Gauge1.Progress:=0;
     Timer1.Enabled:=false;
     btRecord.enabled:=true;
  end;
end;

{here's your hook into managing things on a buffer level:
 this event, if defined, is called for each waveevent.
 see the help file for a definition of the waveEvent structure;
 }

 procedure TMAIN.waveInput1WaveInput(Sender: TObject);
var TWE : TWaveEvent;
begin
log.lines.add('WaveInput');
showInputLevel(self);
   while waveinput1.MessageCount>0 do begin
         TWE:=WaveInPut1.GetWaveEvent;
         BlockWrite(fTMP,TWE.bufData^,TWE.bufSize);
         TWE.Free;
   end;
end;

(*like waveInput1WaveInput, WaveOutput is called, if defined, after each block
is played.   That is, you play a block (call waveOutput1.playbuffer), and, as
a result, your OnWaveOutput event is triggered.   As in this example, a common
action to take would be to play the next buffer; the result is an audio output
stream.   You could acheive similar results by calling playbuffer repeatedly
in a loop, as long as the messageCount was greater than 0*)
procedure TMAIN.WaveOutput1WaveOutput(Sender: TObject);
begin
   log.lines.add('output');
     if FileIsOpen then  begin
     cursize:=readWaveBlock(buffer,buffersize);
     if cursize<buffersize then CloseWaveFile;
     WaveOutput1.AddBlock(buffer,cursize,ID);
     Inc(ID);
     end;
     WaveOutput1.PlayBuffer;
     WaveOutput1.PlayBuffer;
end;

(*this event is triggered, if defined, when waveInput continues
after the ringbuffer is full;  it's up to you to manage the stream
to avoid this, or to do something about it here...*)
procedure TMAIN.waveInput1Overflow(Sender: TObject);
begin
   CloseFile(fTMP);
   log.lines.add('Overflow');
end;

(*this event is triggered, if defined, instead of the OnwaveInput event,
when autoActivation is TRUE, and the current input level (waveInput1.curLevel)
is below the current activation level (waveInput1.activationLevel)  *)
procedure TMAIN.waveInput1Mute(Sender: TObject);
begin
   log.lines.add('mute');
   showInputLevel(Self);
end;

(*this event is triggered, if defined, after the last waveEvent in the
waveOutput ringbuffer is played.*)
procedure TMAIN.WaveOutput1End(Sender: TObject);
begin
   log.lines.add('waveout-end');
   paStatus.caption := 'All done!';
   btPlay.down := false;
   paInfo.caption := intToStr(size)+' of '+intToStr(size);
   waveOutput1.stop;
   waveOutput1.close;
   btPlay.Enabled:=true;
   btRecord.Enabled:=true;
   Gauge1.Progress:=0;
   Timer1.Enabled:=false;
   FreeMem(buffer,buffersize);
end;

procedure TMAIN.showInputLevel(Sender: TObject);
begin
   tbActivationLevel.SelHighEnd:=(WaveInput1.CurLevel) div 100;
   wiCurLevel.Caption:=IntToStr(WaveInput1.CurLevel div 100);
end;

procedure TMAIN.TrackBar1Change(Sender: TObject);
begin
   WaveInput1.ActivationLevel:=(tbActivationLevel.Value);
   wiActivationLevel.Caption:=IntToStr(WaveInput1.ActivationLevel);
end;

procedure TMAIN.btClearClick(Sender: TObject);
begin
   log.clear;
end;

procedure TMAIN.FileListBox1Change(Sender: TObject);
begin
  Gauge1.progress:=0;
end;

procedure TMAIN.Timer1Timer(Sender: TObject);
begin
  Gauge1.progress:= WaveOutput1.GetPosition(TIME_BYTES);
  paInfo.caption := intTostr(Gauge1.progress)+' of '+intToStr(size);
end;

procedure TMAIN.Timer2Timer(Sender: TObject);
begin
 paInfo.Caption:=IntToStr(WaveInput1.GetPosition(TIME_BYTES) div 1024)+
   ' bytes recorded';
end;

procedure TMAIN.btPauseClick(Sender: TObject);
begin
  if btPause.down then
    begin
       if btRecord.down then
          begin
             waveInput1.stop;
             tbActivationLevel.selHighEnd:=0;
          end else
          if btPlay.down then
             waveOutput1.pause else
               btPause.down := false;

    end else
    begin
       if btRecord.down then
          begin
          waveInput1.start;
          end else
          if btPlay.down then
             waveOutput1.resume else
               btPause.down := false;
    end;
end;

procedure TMAIN.btHelpClick(Sender: TObject);
begin
 application.HelpJump('');
end;

end.
